---
- name: "(PRECHECKS)"
  hosts: 'source_cluster:target_cluster'
  gather_facts: true
  become: true
  become_user: "{{ os_pg_user }}"
  any_errors_fatal: true
  tasks:
    - name: '[Prepare] Get Patroni Cluster Name'
      uri:
        url: http://{{ inventory_hostname }}:{{ patroni_restapi_port }}/patroni
      register: patroni_result
      changed_when: false
      tags: always

    - name: '[Prepare] Set the variable: patroni_cluster_name'
      set_fact:
        patroni_cluster_name: "{{ patroni_result.json.patroni.scope }}"
      tags: always

    - name: '[Prepare] Get Patroni Cluster Leader Node'
      uri:
        url: http://{{ inventory_hostname }}:{{ patroni_restapi_port }}/leader
        status_code: 200
      register: patroni_leader_result
      changed_when: false
      failed_when: false
      tags: always

    - name: '[Prepare] Set the variable: patroni_cluster_leader: true'
      set_fact:
        patroni_cluster_leader: true
      when: patroni_leader_result.status == 200
      tags: always

    - name: '[Prepare] Set the variable: patroni_cluster_leader: false'
      set_fact:
        patroni_cluster_leader: false
      when: patroni_leader_result.status != 200
      tags: always

    - name: '[Prepare] Add host to group "source_primary" (in-memory inventory)'
      add_host:
        name: "{{ item }}"
        groups: source_primary
      when: hostvars[item]['patroni_cluster_leader']
      loop: "{{ groups['source_cluster'] }}"
      changed_when: false
      tags: always

    - name: '[Prepare] Add hosts to group "target_primary" (in-memory inventory)'
      add_host:
        name: "{{ item }}"
        groups: target_primary
      when: hostvars[item]['patroni_cluster_leader']
      loop: "{{ groups['target_cluster'] }}"
      changed_when: false
      tags: always

    - name: '[Prepare] Add hosts to group "target_secondary" (in-memory inventory)'
      add_host:
        name: "{{ item }}"
        groups: target_secondary
      when: not hostvars[item]['patroni_cluster_leader']
      loop: "{{ groups['target_cluster'] }}"
      changed_when: false
      tags: always

    - name: "Print Source Patroni Cluster info"
      debug:
        msg:
          - "Source Cluster Name: {{ patroni_cluster_name }}"
          - "Source Cluster Leader: {{ inventory_hostname }}"
      when:
        - inventory_hostname in groups['source_cluster']
        - patroni_cluster_leader
      tags: always

    - name: "Print Target Patroni Cluster info"
      debug:
        msg:
          - "Target Cluster Name: {{ patroni_cluster_name }}"
          - "Target Cluster Leader: {{ inventory_hostname }}"
      when:
        - inventory_hostname in groups['target_cluster']
        - patroni_cluster_leader
      tags: always

- name: "(1/3) Perform Pre-Checks"
  hosts: 'source_cluster:target_cluster'
  gather_facts: false
  become: true
  become_user: "{{ os_pg_user }}"
  any_errors_fatal: true
  tasks:
    - name: "Running Pre-Checks"
      include_role:
        name: physical-to-logical
        tasks_from: pre_checks
  tags:
    - physical-to-logical
    - pre-checks

...
